/* projekt3.rex */

--Bildbearbeitung mit Python
--     bat-Datei zum starten von Python                python skript starten |  Parameter, die übergeben werden für Parse in Python Skript
-- &-Zeichen um Befehle nacheinander auszuführen
--cmd='C:\Users\laptop2pc\anaconda3\Scripts\activate.bat & python projekt3.py Bild1h.jpg output.png 2000'
HomeDir1 =  VALUE( "HOMEPATH",,ENVIRONMENT)
cmd=HomeDir1||'\anaconda3\Scripts\activate.bat & python projekt3.py Bild1h.jpg output.png 300'
cmd
Say 'Output of "'cmd'"'

-- CSV-Datei öffnen:
csv=.stream~new("umsatz.csv")~~open

Excel = .OLEObject~New("Excel.Application")
WorkSheet = Excel~Workbooks~Add~Worksheets[1] 
Excel~Visible = .true 
		
-- temporäres Verzeichnis für die Output-Daten		
cmd='mkdir 'HomeDir1||'\Downloads\tmp'
cmd
Say 'Output of "'cmd'"'	
		
menge=.array ~of("A","B")
k=0
l=0
DO i OVER csv
	k=k+1  -- Zeilen (1,2,...)

	zeile=translate(i,'',',') --r remove , from csv
	PARSE VAR zeile jahr umsatz

	a=menge[1]||k -- zuerst "A1", dann "A2", ...
	b=menge[2]||k -- zuerst "B1", dann "B2", ...

	WorkSheet~Range(a)~Select
	WorkSheet~Range(a)~Value = jahr
	WorkSheet~Range(b)~Select
	WorkSheet~Range(b)~Value = umsatz
END
csv~close

-- Diagramm erstellen
Excel~Charts~Add
Excel~ActiveChart~ChartType = 74

Excel~ActiveChart~Location(Excel~GetConstant("XlLocationAsObject"),"Tabelle1")
Excel~ActiveChart~FullSeriesCollection(2)~Delete
Excel~ActiveChart~FullSeriesCollection(1)~XValues = "=Tabelle1!$A$2:$A$50"
Excel~ActiveChart~FullSeriesCollection(1)~Values = "=Tabelle1!$B$2:$B$50"
Excel~ActiveChart~ChartTitle~Text = "Umsatz in Millionen Euro"

Excel~ActiveChart~Legend~Select
Excel~Selection~Delete
--Excel~ActiveChart~ChartArea~Copy


csv=.stream~new("Namen.csv")~~open
Word = .OLEObject~New("Word.Application")
Word~Visible = .TRUE
DO i OVER csv
			/* Word visible */
	Document = Word~Documents~Add	/* create new document */
	Selection = Word~Selection		/* get the selection object and enter text */

	i=translate(i,' ',',') --r remove , from csv
	--Selection~TypeText(i) direkte Ausgabe, Reihenfolge nicht verändert
	PARSE VAR i vorname name wert
	say name
		----------------------------------
    Font = Selection~Font			/* get the font object */
	Font~Name="Avenir Next Heavy"
	Font~Size="18"
	Font~bold = .true
	Font~italic = .true
	Selection~TypeText("HAPPY BIRTHDAY")
	Selection~TypeParagraph
	Selection~TypeText(vorname)
	Selection~TypeParagraph
	Selection~InlineShapes~AddPicture("C:\Users\laptop2pc\Downloads\output.png" )
	Font~bold = .false
	Font~italic = .false
	
	Selection~TypeParagraph
	Selection~TypeText("Alles Gute zum Geburtstag am ")
	Selection~TypeText(wert)
	Selection~TypeParagraph
	Selection~TypeText("fuer ")
	Selection~TypeText(vorname)
	Selection~TypeText(" ")
	Selection~TypeText(name)
	Selection~TypeParagraph
	Selection~TypeParagraph
	Selection~TypeText("Thank you for your hard work and dedication!")

	Selection~TypeParagraph
	Excel~ActiveChart~ChartArea~Copy -- Umsatzdiagramm einfügen in Word-Datei
	Selection~Paste                  -- von der Zwischenablage
	
	--===============================
	 Font = Selection~Font			/* get the font object */
	Font~Name="Avenir Next Heavy"
	Font~Size="11"
	Selection~TypeParagraph
	Selection~TypeText("We are looking forward working with you for many more years to come!")
	Selection~TypeParagraph
	Selection~TypeText("Yours sincerly,")
	Selection~TypeParagraph
	Selection~TypeParagraph
	Selection~TypeParagraph
	Selection~TypeText("___________________________                                                            ___________________________")
	Selection~TypeParagraph
	Selection~TypeText("CEO                                                                                                 Manager")
	--================================
	

	--HomeDir1 =  VALUE( "HOMEPATH",,ENVIRONMENT)	/* save the created WORD file (3x) */
	FileName = HomeDir1 || "\Downloads\tmp\" || name
	Document~SaveAs(FileName)
	say FileName
		
	say "next ..."
END
Word~Quit
------------
say "ready for saving files"
HomeDir1 =  VALUE( "HOMEPATH",,ENVIRONMENT)	/* save the created EXCEL file */
FileName = HomeDir1 || "\Downloads\tmp\" || "Tabelle"
WorkSheet~SaveAs(FileName)
say FileName                             
Excel~Quit
timeout 3

--          7-Zip  Programm starten  append(Anhängen)  Output-Datei   Quell-Verzeichnis 
cmd='C:\"Program Files"\7-Zip\7z.exe a output.zip 'HomeDir1||'\Downloads\tmp\*.*'
say cmd
cmd
Say 'Output of "'cmd'"'

timeout 3
cmd='rmdir 'HomeDir1||'\Downloads\tmp /S /Q'
say cmd
cmd
Say 'Output of "'cmd'"'
